# Code of Conduct

## Values
- Communication
- Courage
- Excellence
- Feedback
- Respect
- Simplicity

## Communication
- Don't ask to ask, just ask.
- If you feel that folks are not on the same page, communicate.

## Courage
- Use courage-enabling techniques, like TDD.
- If you feel that folks are probably on the same page, don't waste time asking, just do it.

<figure>

  > Fear is the path to the dark side.
  > Fear leads to anger.
  > Anger leads to hate.
  > Hate leads to suffering.

  <figcaption>― Yoda, Star Wars Episode I: The Phantom Menace</figcaption>
</figure>

## Excellence
- Always try to do the best job you could.
- Always continue to improve.

<figure>

  > Embrace Change

  <figcaption>― Kent Beck, XP Mantra</figcaption>
</figure>

<figure>

  > Given two otherwise roughly equivalent options,
  > always choose the path that makes future change easier.

  <figcaption>― "Pragmatic" Dave Thomas</figcaption>
</figure>

## Feedback
- If something's not right, communicate.
- Make sure the system communicates as well if something is not right.
- Inspect, that is gather information, and adapt, that is, improve based on the information.

## Respect
- Respect other's opinions and experiences.
- The AceUnit community will not tolerate hate.

## Simplicity
<figure>

  > A designer knows they have achieved perfection
  > not if there is nothing left to add
  > but if there is nothing left to remove.

  <figcaption>vu2015  Antoine de Saint-Exupéry</figcaption>
<figure>

<figure>

  > Everything should be made as simple as possible, but not simpler.

  <figcaption>― <cite>Albert Einstein</cite></figcaption>
</figure>

- Keep it Simple, Stupid
- Always try the simplest thing that could possibly work.
- Follow the 4 Rules of Simple Design (in their priority order):

<figure>

  > 1. Passes the Tests
  > 1. Communicates Intent
  > 1. Less Duplication (aka DRY)
  > 1. Fewer Elements

  <figcaption>― <cite>Kent Beck</cite>, <cite>Martin Fowler</cite>, 4 Rules of Simple Design</figcaption>
</figure>
